libcwd: The C++ Debugging Support Library - Reference Manual
Author: Carlo Wood
Description: C++ debugging support library with ostream debug output
Keywords: libcwd, debug output, debug facility, debug channel, object orientation, OO, C++, nested debug output, ostream, memory allocation, debugging, source file and line number

Main Page Reference Manual Namespace List Compound List Namespace Members Compound Members File Members

# libcwd::alloc_ct Class Reference
[Finding (Information About) Memory Allocations]

An object of type alloc_ct contains information about one allocated memory block. More...

`#include <class_alloc.h>`

List of all members.

## Public Member Functions
size_t | size (void) const
| The allocated size in bytes.
void const * | start (void) const
| A pointer to the start of the allocated memory block.
memblk_types_nt | memblk_type (void) const
| A flag indicating the type of allocation.
type_info_ct const & | type_info (void) const
| A reference to the type info of the pointer to the allocated memory block.
char const * | description (void) const
| A pointer to a description of the allocated memory block.
struct timeval const & | time (void) const
| The time at which this allocation was made.
## Protected Member Functions
| alloc_ct (void const *s, size_t sz, memblk_types_nt type, type_info_ct const &ti, struct timeval const &t)
| Construct an `alloc_ct` object with attributes s, sz, type, ti, t and l.
virtual | ~alloc_ct ()
| Destructor.
## Protected Attributes
void const * | a_start
| Duplicate of (original) memblk_key_ct.
size_t | a_size
| Duplicate of (original) memblk_key_ct.
memblk_types_nt | a_memblk_type
| A flag which indicates the type of allocation.
type_info_ct const * | type_info_ptr
| Type info of related object.
_private_::smart_ptr | a_description
| A label describing this memblk.
struct timeval | a_time
| The time at which the memory was allocated.

## Detailed Description

An object of type alloc_ct contains information about one allocated memory block.

## Member Function Documentation

char const* libcwd::alloc_ct::description | ( | void |  | ) | const`[inline]`

A pointer to a description of the allocated memory block.

This is a character string that is the result of writing the second parameter of AllocTag() to an ostrstream.

References a_description.

struct timeval const& libcwd::alloc_ct::time | ( | void |  | ) | const`[inline, read]`

The time at which this allocation was made.

Returns:
  the time at which the memory was allocated, as returned by a call to gettimeofday.

References a_time.

type_info_ct const& libcwd::alloc_ct::type_info | ( | void |  | ) | const`[inline]`

A reference to the type info of the pointer to the allocated memory block.

Returns:
  a reference to the static type_info_ct object that is returned by a call to type_info_of(p1). Where `p1` is the first parameter that was passed to AllocTag().

References type_info_ptr.